<?php

namespace App\Filament\Imports;

use App\Models\ProductionCharacteristic;
use Filament\Actions\Imports\ImportColumn;
use Filament\Actions\Imports\Importer;
use Filament\Actions\Imports\Models\Import;

class ProductionCharacteristicImporter extends Importer
{
    protected static ?string $model = ProductionCharacteristic::class;

    public static function getColumns(): array
    {
        return [
            ImportColumn::make('plant')
                ->requiredMapping()
                ->relationship()
                ->rules(['required']),
            ImportColumn::make('line')
                ->requiredMapping()
                ->relationship()
                ->rules(['required']),
            ImportColumn::make('item')
                ->requiredMapping()
                ->relationship()
                ->rules(['required']),
            ImportColumn::make('machine')
                ->requiredMapping()
                ->relationship()
                ->rules(['required']),
            ImportColumn::make('production_order'),
            ImportColumn::make('serial_number'),
            ImportColumn::make('characteristic_name'),
            ImportColumn::make('observed_value'),
            ImportColumn::make('status'),
            ImportColumn::make('inspection_status'),
            ImportColumn::make('remark'),
            ImportColumn::make('created_by'),
            ImportColumn::make('updated_by'),
        ];
    }

    public function resolveRecord(): ?ProductionCharacteristic
    {
        // return ProductionCharacteristic::firstOrNew([
        //     // Update existing records, matching them by `$this->data['column_name']`
        //     'email' => $this->data['email'],
        // ]);

        return new ProductionCharacteristic();
    }

    public static function getCompletedNotificationBody(Import $import): string
    {
        $body = 'Your production characteristic import has completed and ' . number_format($import->successful_rows) . ' ' . str('row')->plural($import->successful_rows) . ' imported.';

        if ($failedRowsCount = $import->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to import.';
        }

        return $body;
    }
}
